///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;

namespace Fluogen.DeployedScripts.ColorExtractors
{
	public class Palette : ColorExtractor<DummyScriptConfiguration>
	{
		public override string Description => "Palette[ rc ]";

		public override ExtractedColor Extract( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, ColorDeterminant a )
		{
			double paletteColorScalar = a.Main;

			int paletteColorIndex = fx.ActivePalette.GetColorIndex( paletteColorScalar );
			var color = fx.ActivePalette.GetColor( paletteColorIndex );

			return new ExtractedColor( color, paletteColorScalar, paletteColorIndex );
		}
	}
}
