///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using Fluogen.Dependz;
using Fluogen.Dependz.ColorReducers;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.ColorReducers
{
	public class PhiOutside : AsymptoticColorReducer<DummyScriptConfiguration>
	{
		public override string Description => "rs.PhiOutside( s1 ); PhiOutside = |x| <= s1 ? (x) : (s1 ^ 2 / x)";

		public override void Validate( IFluonConfiguration fc, IColorReducerConfiguration crp )
		{
			base.Validate( fc, crp );

			if( crp.S1.IsZeroWithinEps() )
				throw new ArgumentException( $"{crp.Name}: crp.S1 == 0" );
		}

		protected override double ReduceAsymptoticallyToUnitary( IFluonContext fx, IFluonConfiguration fc, IColorReducerConfiguration crp
			, double x )
		{
			return x.PhiOutside( crp.S1 );
		}
	}
}
