///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.ColorReducers
{
	public class ScaleUnitaryMirrored : ColorReducer<DummyScriptConfiguration>
	{
		public override string Description => "rs.ScaleUnitaryMirrored( s1, s2 )";

		public override bool SupportsSupraunitaryInputValues => false;

		public override void Validate( IFluonConfiguration fc, IColorReducerConfiguration crp )
		{
			base.Validate( fc, crp );

			if( crp.S1 <= 0 || crp.S1 >= 1 )
				throw new ArgumentException( $"{crp.Name}: crp.S1 <= 0 || crp.S1 >= 1" );
			if( crp.S2 <= 0 || crp.S2 >= 1 )
				throw new ArgumentException( $"{crp.Name}: crp.S2 <= 0 || crp.S2 >= 1" );
		}

		public override double ReduceToUnitary( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, IColorReducerConfiguration crp
			, double x )
		{
			return x.ScaleUnitaryMirrored( crp.S1, crp.S2 );
		}
	}
}
