///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Fluogen.Dependz.Contexts;
using Fluogen.Dependz.FluonGenerators;
using Got.Libraries;

namespace Fluogen.DeployedScripts.FluonGenerators
{
	public class Slide : IteratedFluonGeneratorWithSingleDomain<DummyScriptConfiguration, DummyCarryState>
	{
		protected override Mdn ProcessCodomainIteration( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y
			, ref DummyCarryState carryState )
		{
			Mdn m1 = fc.FluonGeneratorM1;

			double t0 = (m1[ 0 ] + y[ 0 ] - y[ 1 ] + y[ 2 ]).Atan() + x[ 0 ];
			double t1 = (m1[ 1 ] + 2 * y.CartesiansProduct()).Atan() + x[ 1 ];
			double t2 = (m1[ 2 ] + y.CartesiansSum()).Atan() + x[ 2 ];

			return new Mdn( new double[] { t0, t1, t2 } );
		}
	}
}
