///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Fluogen.Dependz.FluonGenerators;
using Got.Libraries;

namespace Fluogen.DeployedScripts.FluonGenerators
{
	public class Her : IteratedFluonGeneratorWithSingleDomain<DummyScriptConfiguration, double>
	{
		public override string Description => "((y ^ s1).AddOnAxis( 0, x.r ^ 2 ) + m1) ^ s2; y0 = x";

		protected override double InitializePixelCarryState( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x )
		{
			return x.RadiusSqr;
		}

		protected override Mdn ProcessCodomainIteration( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y
			, ref double carryState )
		{
			double s1 = fc.FluonGeneratorS1;
			double s2 = fc.FluonGeneratorS2;
			Mdn m1 = fc.FluonGeneratorM1;

			return (y.OptimizedPowDnD1A( s1 ).AddOnAxis( 0, carryState ) + m1).OptimizedPowDnD1A( s2 );
		}
	}
}
