///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;
using Fluogen.Dependz.MdnReducers;
using Got.Libraries;

namespace Fluogen.DeployedScripts.MdnReducers
{
	public class HarshLnEvLnEt : FractionalIterations<DummyScriptConfiguration>
	{
		public override string Description => "1 - ev.LoopLnA( s1 ) / et.LoopLnA( s1 - 1 )";

		private double EtLoopLn;

		public override void InitializeGlobalState( IFluonConfiguration fc )
		{
			double et = fc.EscapeThreshold;
			int count = (int)fc.MdnReducerS1;

			EtLoopLn = et.LoopLnA( count - 1 );
		}

		protected override double IterationFraction( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y, Mdn yp
			, double ev, double evp, ColorDeterminant a, int ri, bool hasEscaped )
		{
			int count = (int)fc.MdnReducerS1;

			return 1 - ev.LoopLnA( count ) / EtLoopLn;
		}
	}
}
