///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;

namespace Fluogen.DeployedScripts.Palettes
{
	public class Autumn : MonotoneCubicGradientPalette<DummyScriptConfiguration>
	{
		protected override IGradientPaletteMarkList GetMarks( IFluonConfiguration fc )
		{
			var colorModel = PX.OC.ColorModel.Value;

			switch( colorModel )
			{
				case ColorModelName.Hsl:
					return new GradientPaletteMarkList
					{
						Hsl( 0.0000,   830, 10000, 10000 ),
						Hsl( 0.0250,   830, 10000,  9600 ),
						Hsl( 0.1500,   750,  9000,  4400 ),
						Hsl( 0.2100,   750, 10000,  9000 ),
						Hsl( 0.3000,   750, 10000,  2400 ),
						Hsl( 0.3500,   750,  9000,  4400 ),
						Hsl( 0.4750,   830, 10000,  9600 ),
						Hsl( 0.5000,   830, 10000, 10000, true ),
						Hsl( 0.5900,  6000, 10000,  6700 ),
						Hsl( 0.6500,  6000, 10000,  4300 ),
						Hsl( 0.7000,  6000, 10000,  2300 ),
						Hsl( 0.7350,  6000, 10000,   600 ),
						Hsl( 0.7500,  6000, 10000,     0 ),
						Hsl( 0.7650,  6000, 10000,   600 ),
						Hsl( 0.8000,  6000, 10000,  2300 ),
						Hsl( 0.8500,  6000, 10000,  4300 ),
						Hsl( 0.9100,  6000, 10000,  6700 ),
						Hsl( 1.0000,   830, 10000, 10000 )
					};
				default:
					throw new InvalidOperationException( $"Unhandled color model \"{colorModel}\"" );
			}
		}
	}
}
