///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;
using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;

namespace Fluogen.DeployedScripts.Palettes
{
	public class Highlight : Palette<DummyScriptConfiguration>
	{
		public override int FullSize => 256;
		public override int QuickSize => 256;

		protected override void InitializeCache( IFluonConfiguration fc )
		{
		}

		protected override IList<PixelRgbColor> CacheColors()
		{
			var colors = new PixelRgbColor[ ActualSize ];

			for( int i = 0; i < 256; i++ )
				colors[ i ] = PixelRgbColor.FromRgb8Bits( (byte)i, (byte)i, (byte)i );

			return colors;
		}

		protected override PixelRgbColor ComputeColor( IFluonConfiguration fc, double scalar )
		{
			throw new InvalidOperationException();
		}
	}
}
