///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;

namespace Fluogen.DeployedScripts.Palettes
{
	public class TestHslMarkList : MonotoneCubicGradientPalette<DummyScriptConfiguration>
	{
		protected int Hue1 => 7400;
		protected int Hue2 => 6900;

		protected int Saturation1 => 10000;
		protected int Saturation2 => Saturation1;
		protected int Saturation3 => Saturation1;

		protected override IGradientPaletteMarkList GetMarks( IFluonConfiguration fc )
		{
			int hue1 = fc.BitonalGradientPaletteOverridingConfiguration.ToneHue1 != null
				? fc.BitonalGradientPaletteOverridingConfiguration.ToneHue1.Value : Hue1;
			int hue2 = fc.BitonalGradientPaletteOverridingConfiguration.ToneHue2 != null
				? fc.BitonalGradientPaletteOverridingConfiguration.ToneHue2.Value : Hue2;

			return new GradientPaletteMarkList
			{
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.00,  hue1, Saturation1,  0, ColorModelName.Hsl, false ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.10,  hue1, Saturation1,  2500, ColorModelName.Hsl, false ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.20,  hue1, Saturation1,  3800, ColorModelName.Hsl, false ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.35,  hue1, Saturation1,  6000, ColorModelName.Hsl, false ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.50,  hue1, Saturation1, 10000, ColorModelName.Hsl, true ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.65,  hue1, Saturation1,  6000, ColorModelName.Hsl, false ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.80,  hue1, Saturation1,  3800, ColorModelName.Hsl, false ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 0.90,  hue1, Saturation1,  2500, ColorModelName.Hsl, false ),
				PaletteExtensions.GetFixedMarkFromTypeableColor( 1.00,  hue1, Saturation1,  0, ColorModelName.Hsl, false )
			};
		}
	}
}
