///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.ScalarReducers
{
	public class LoopLnAbsXPlus1 : ScalarReducer<DummyScriptConfiguration>
	{
		public override string Description => "a.LoopLnAbsXPlus1( s1 ); LoopLnAbsXPlus1 = ((1 + |x|).Ln).Loop( s1 )";

		public override void Validate( IFluonConfiguration fc )
		{
			base.Validate( fc );

			if( fc.ScalarReducerS1 <= 0 || !fc.ScalarReducerS1.IsInteger() )
				throw new ArgumentException( $"{nameof( LoopLnAbsXPlus1 )}: ScalarReducerS1 <= 0 || !IsInteger( ScalarReducerS1 )" );
		}

		public override ColorDeterminant Reduce( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, ColorDeterminant a )
		{
			int count = (int)fc.ScalarReducerS1;

			return a.Replace( a.Main.LoopLnAbsXPlus1( count ) );
		}
	}
}
